#include <stdio.h>
#include <stdlib.h>

int* AlocirajNiz(int n)
{
    return (int*) malloc (n * sizeof(int));
}

void SetujNiz(int *niz, int n, int vrednost)
{
    for(int i = 0; i < n; i++)
        niz[i] = vrednost;
}

int** AlocirajMatricu(int n, int m)
{
    int ** matrica = (int**) malloc (n * sizeof(int*));
    for(int i = 0; i < n; i++)
    {
        matrica[i] = AlocirajNiz(m);
        SetujNiz(matrica[i], m, 0);
    }


    return matrica;
}

void StampajNiz(int* niz,int i, int n)
{
    for(i; i < n; i++)
        printf("%d ", niz[i]);
}

void StampajMatricu(int **matrica, int n, int m)
{
    for(int i = 0 ; i < n; i++)
    {
        StampajNiz(matrica[i], 0, m);
        printf("\n");
    }
}

int main()
{
    int sirinaZida, brojOrmara, brojStolova, *sirinaOrmara, *cenaOrmara, *sirinaStolova, *cenaStolova;
    int **opt, **prethodni;

    scanf("%d", &brojOrmara);
    scanf("%d", &brojStolova);

    sirinaOrmara = AlocirajNiz(brojOrmara + 1);
    cenaOrmara = AlocirajNiz(brojOrmara + 1);

    sirinaStolova = AlocirajNiz(brojStolova + 1);
    cenaStolova = AlocirajNiz(brojStolova + 1);

    for(int i = 1; i <= brojOrmara; i++)
        scanf("%d %d", &sirinaOrmara[i], &cenaOrmara[i]);

    for(int i = 0; i < brojStolova; i++)
        scanf("%d %d", &sirinaStolova[i], &cenaStolova[i]);

    scanf("%d", &sirinaZida);

    opt = AlocirajMatricu(brojStolova, sirinaZida + 1);
    prethodni = AlocirajMatricu(brojStolova, sirinaZida + 1);

    for(int i = 0; i < brojStolova; i++) 
    {
        for(int j = sirinaStolova[i]; j <= sirinaZida; j++)
        {
            for(int k = 1; k <= brojOrmara; k++)
            {
                if(sirinaOrmara[k] <= j)
                {
                    if(opt[i][j] > opt[i][j - sirinaOrmara[k]] + cenaOrmara[k] || opt[i][j] == 0)
                    {
                        opt[i][j] = opt[i][j - sirinaOrmara[k]] + cenaOrmara[k];
                        prethodni[i][j] = k;
                    }

                }
            }
        }
    }

    int min, minIndeks;
    min = opt[brojStolova - 1][sirinaZida];

    for(int i = 0; i < brojStolova; i++)
    {
        if(opt[i][sirinaZida] != 0 && opt[i][sirinaZida] < min)
        {
            min = opt[i][sirinaZida];
            minIndeks = i;
        }
    }
    StampajMatricu(opt, brojStolova, sirinaZida + 1);



    printf("\nCena = %d ", opt[minIndeks][sirinaZida]);
    int i = sirinaZida;
    while(i > 0 && opt[minIndeks][i] > 0)
    {
        printf("%d ", prethodni[minIndeks][i]);
        i -= sirinaOrmara[prethodni[minIndeks][i]];
    }

    return 0;
}
