#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 0
#define SKUP_N 1

int m,n, *BN;
double **a, *b, *c, *x;
double v;

void unosPodataka() {
	int i;
	
	double jecamSvetlo, hmeljSvetlo, psenicaSvetlo, kvasacSvetlo;
	double jecamTamno, hmeljTamno, psenicaTamno, kvasacTamno;
	double jecamNefiltrirano, hmeljNefiltrirano, psenicaNefiltrirano, kvasacNefiltrirano;

	double cenaSvetlo, cenaTamno, cenaNefiltrirano;
	double zaliheJecam, zaliheHmelj, zalihePsenica, zaliheKvasac; 
	
	m=3;
	n=4;
	
	BN=(int*)malloc((m+n+1)*sizeof(int));
	
	a=(double**)malloc((m+n+1)*sizeof(double*));
	for(i=1; i<=m+n; i++) a[i]=(double*)malloc((m+n+1)*sizeof(double));
	
	b=(double*)malloc((m+n+1)*sizeof(double));
	c=(double*)malloc((m+n+1)*sizeof(double));
	x=(double*)malloc((m+n+1)*sizeof(double));	
	
	
	scanf("%lf%lf%lf%lf", &jecamSvetlo, &hmeljSvetlo, &psenicaSvetlo, &kvasacSvetlo);
	scanf("%lf%lf%lf%lf", &jecamTamno, &hmeljTamno, &psenicaTamno, &kvasacTamno);
	scanf("%lf%lf%lf%lf", &jecamNefiltrirano, &hmeljNefiltrirano, &psenicaNefiltrirano, &kvasacNefiltrirano);

	scanf("%lf%lf%lf", &cenaSvetlo, &cenaTamno, &cenaNefiltrirano);
	scanf("%lf%lf%lf%lf", &zaliheJecam, &zaliheHmelj, &zalihePsenica, &zaliheKvasac);	
	
	for(i=1; i<=m+n; i++) {
		if(i<=n) {
			c[i]=1;
			b[i]=0;
			BN[i]=SKUP_N;
		}
		else {
			c[i]=0;
			BN[i]=SKUP_B;
		}
	}
		
	a[n+1][1]=jecamSvetlo;
	a[n+1][2]=hmeljSvetlo; 
	a[n+1][3]=psenicaSvetlo; 
	a[n+1][4]=kvasacSvetlo;
	
	a[n+2][1]=jecamTamno; 
	a[n+2][2]=hmeljTamno; 
	a[n+2][3]=psenicaTamno; 
	a[n+2][4]=kvasacTamno;
	
	a[n+3][1]=jecamNefiltrirano; 
	a[n+3][2]=hmeljNefiltrirano; 
	a[n+3][3]=psenicaNefiltrirano; 
	a[n+3][4]=kvasacNefiltrirano;

	//cenaSvetlo, cenaTamno, cenaNefiltrirano;
	
	//a[n][1]=cenaSvetlo*0.1;		a[n][2]=cenaTamno*0.15;		a[n][3]=cenaNefiltrirano*0.22;

	b[n+1]=cenaSvetlo*0.1;		b[n+2]=cenaTamno*0.15;		b[n+3]=cenaNefiltrirano*0.22;


	//b[n+1]=zaliheJecam; b[n+2]=zaliheHmelj; b[n+3]=zalihePsenica; b[n+4]=zaliheKvasac;
	a[n][1]=zaliheJecam; a[n][2]=zaliheHmelj; a[n][3]=zalihePsenica; a[n][4]=zaliheKvasac;
	
	v=0;	
}

int nadjiUlaz() {
	int i, e=-1;
	
	for(i=1; i<=m+n; i++) {
		if(BN[i]==SKUP_N && c[i]>0) {
			e=i;
			break;
		}
	}
	
	return e;
}

int nadjiIzlaz(int e) {
	int i, l=-1;
	double min=-1;
	
	for(i=1; i<=m+n; i++) {
		if(BN[i]==SKUP_B && a[i][e]>0) {
			if(l==-1) {
				min=b[i]/a[i][e];
				l=i;
			}
			else if(b[i]/a[i][e] < min) {
				min=b[i]/a[i][e];
				l=i;
			}
		}
	}
	
	return l;
}

void pivot(int e, int l) {
	int i, j;
	
	b[l]=b[l]/a[l][e];
	
	for(i=1; i<=m+n; i++) {
		if(BN[i]==SKUP_N && i!=l) {
			
		}
	}
	
	a[e][l]=1/a[l][e];
	
	for(i=1; i<=m+n; i++) {
		if(BN[i]==SKUP_B && i!=l) {
			b[i]=b[i]-b[e]*a[l][e];
		}
		
		for(j=1; j<=m+n; j++) {
			if(BN[j]==SKUP_N && j!=e) {
				a[i][j]=a[i][j]-a[e][j]*a[l][e];
			}
		}
		
		a[i][l]=-a[i][l]*a[e][l];
	}
		
	v=v+c[e]*b[e];
	
	for(j=1; j<=m+n; j++) {
		if(BN[i]==SKUP_N && j!=e) {
			c[j]=c[j]-a[j][e];
		}
	}
	
	c[l]=-c[l]*a[e][l];
	
	BN[e]=SKUP_B;
	BN[l]=SKUP_N;
}

int main() {
	int i, e, l;
	
	unosPodataka();
	
	while((e=nadjiUlaz())!=0) {
		l=nadjiIzlaz(e);

		if(l==-1) {
			//printf("greska");
			break;
		}
		else {
			pivot(e, l);
		}		
	}
	
	if(e==-1) {
				
		for(i=1; i<=n; i++) {
			if(BN[i]==SKUP_B) {
				x[i]=b[i];
			}
			else {
				x[i]=0;
			}
		}

		printf("%lf\n", v);			
		for(i=1; i<=n; i++) printf("%lf", x[i]);
	}
	
	return 0;
}
