#include <stdio.h>
#include <stdlib.h>

#define SKUP_N 0
#define SKUP_B 1

int m, n;
int *BN;
double **a, *b, *c, *x, v;

void unesiPodatke()
{
	int i;
	
	n = 3;
	m = 4;
	
	a = (double**)malloc((m+n)*sizeof(double*));
	for(i=0;i<(m+n);i++)
		a[i] = (double*)malloc((m+n)*sizeof(double));
		
	b = (double*)malloc((m+n)*sizeof(double));
	c = (double*)malloc((m+n)*sizeof(double));
	x = (double*)malloc((m+n)*sizeof(double));
	
	BN = (int*)malloc((m+n)*sizeof(int));
	
	scanf("%lf",&a[n][0]);
	scanf("%lf",&a[n+1][0]);
	scanf("%lf",&a[n+2][0]);
	scanf("%lf",&a[n+3][0]);
	
	scanf("%lf",&a[n][1]);
	scanf("%lf",&a[n+1][1]);
	scanf("%lf",&a[n+2][1]);
	scanf("%lf",&a[n+3][1]);
	
	scanf("%lf",&a[n][2]);
	scanf("%lf",&a[n+1][2]);
	scanf("%lf",&a[n+2][2]);
	scanf("%lf",&a[n+3][2]);
	
	for(i=0;i<n;i++)
	{
		BN[i] = SKUP_N;
		b[i] = 0;
		scanf("%lf",&c[i]);
		if (i==0)
			c[i] = c[i]*0.10;
		else if (i==1)
			c[i] = c[i]*0.15;
		else if (i==2)
			c[i] = c[i]*0.22;
	}
	
	for(i=n;i<(m+n);i++)
	{
		BN[i] = SKUP_B;
		c[i] = 0;
		scanf("%lf",&b[i]);
	}
	
	v = 0;
}

int nadjiUlaz()
{
	int e = -1;
	int i;
	
	for(i=0;i<(m+n);i++)
		if (BN[i]==SKUP_N && c[i]>0)
		{
			e = i;
			break;
		}
	
	return e;
}

int nadjiIzlaz(int e)
{
	int l = -1;
	int i;
	double min;
	
	for(i=0;i<(m+n);i++)
		if (BN[i]==SKUP_B && b[i]>0)
			if (l==-1 || b[i]/a[i][e] < min)
			{
				l = i;
				min = b[i]/a[i][e];
			}
	
	return l;
}

void pivot(int e, int l)
{
	int i,j;
	
	b[e]=b[l]/a[l][e];
	for(j=0;j<(m+n);j++)
		if (BN[j]==SKUP_N && j!=e)
			a[e][j] = a[l][j]/a[l][e];
	a[e][l]=1/a[l][e];
	
	for(i=0;i<(m+n);i++)
		if (BN[i]==SKUP_B && i!=l)
		{
			b[i]-=a[i][e]*b[e];
			for(j=0;j<(m+n);j++)
				if (BN[j]==SKUP_N && j!=e)
					a[i][j]-=a[e][j]*a[i][e];
			a[i][l]=-a[e][l]*a[i][e];
		}
		
	v += c[e]*b[e];
	for(j=0;j<(m+n);j++)
		if (BN[j]==SKUP_N && j!=e)
			c[j]-=c[e]*a[e][j];
	c[l]=-c[e]*a[e][l];
	
	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
}

int main()
{
	unesiPodatke();
	
	int e,l;
	int i;
	
	while((e=nadjiUlaz())!=-1)
	{
		l = nadjiIzlaz(e);
		if (l==-1)
		{
			printf("Problem je neogranicen!\n");
			break;
		}
		else
			pivot(e,l);
	}
	
	if (e==-1)
	{
		for(i=0;i<n;i++)
			if (BN[i]==SKUP_B && b[i]>0)
				x[i] = b[i];
			else
				x[i] = 0;
				
		printf("%.3lf\n",v);
		for(i=0;i<n;i++)
			printf("%.3lf ",x[i]);
		printf("\n");
	}
	
	return 0;
}
