#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0

double **a, *jecam, *hmelj, *psenica, *kvasac;
double *b, *c, *cene, *zalihe, *x, *NB;
double  v;
int m, n;
void unesiPodatke()
{
	int i, j;
	m = 4;
	n = 3;
	jecam = (double*)malloc((n+1)*sizeof(double));
	hmelj = (double*)malloc((n+1)*sizeof(double));
	psenica = (double*)malloc((n+1)*sizeof(double));
	kvasac = (double*)malloc((n+1)*sizeof(double));
	zalihe = (double*)malloc((n+1)*sizeof(double));
	cene = (double*)malloc((n+1)*sizeof(double));
	
	NB = (double*)malloc((m+n+1)*sizeof(double));
	c = (double*)malloc((m+n+1)*sizeof(double));
	b = (double*)malloc((m+n+1)*sizeof(double));
	x = (double*)malloc((m+n+1)*sizeof(double));
	a = (double**)malloc((m+n+1)*sizeof(double*));
	for(i = 0; i <= m+n; i++)
		a[i] = (double*)malloc((m+n+1)*sizeof(double));
	
	for(i = 1; i <= n; i++)
	{
		scanf("%lf%lf%lf%lf", &jecam[i], &hmelj[i], &psenica[i], &kvasac[i]);
	}
	for(i = 1; i <= n; i++)
		scanf("%lf", &cene[i]);
		
	for(i = 1; i <= m; i++)
		scanf("%lf", &zalihe[i]);
		
	c[1] = cene[1]*(10.0/100.0); NB[1] = SKUP_N; b[1] = 0;
	c[2] = cene[2]*(15.0/100.0); NB[2] = SKUP_N; b[2] = 0;
	c[3] = cene[3]*(22.0/100.0); NB[3] = SKUP_N; b[3] = 0;
	
	for(i = n+1; i <= m+n; i++)
	{
		b[i] = zalihe[i-n];
		NB[i] = SKUP_B;
		c[i] = 0;
	}
	for(i = 1; i <= n; i++)
	{
		a[n+1][i] = jecam[i];
		a[n+2][i] = hmelj[i];
		a[n+3][i] = psenica[i];
		a[n+4][i] = kvasac[i];
	}
	v = 0;
	
}

int nadjiUlaz()
{
	int e = -1, i;
	for(i = 1; i <= m+n; i++)
	{
		if(NB[i] == SKUP_N)
		{
			if(c[i] > 0)
			{
				e = i;
				break;
			}
		}
	}
	return e;
}

int nadjiIzlaz(int e)
{
	int l = -1, i;
	int min = -1;
	for(i = 1; i <= n+m; i++)
	{
		if(NB[i] == SKUP_B && a[i][e] > 0)
		{
			if(min == -1 || min > (b[i]/a[i][e]))
			{
				min = b[i] / a[i][e];
				l = i;
			}
		}
	}
	return l;
}

void pivot(int e, int l)
{
	int i, j;
	b[e] = b[l] / a[l][e];
	a[e][l] = 1 / a[l][e];
	
	for(i = 1; i <= m+n; i++)
	{
		if(NB[i] == SKUP_N && i != e)
		{
			a[e][i] = a[l][i]/a[l][e];
		}
	}
	
	for(i = 1; i <= n+m; i++)
	{
		if(NB[i] == SKUP_B && i != l)
		{
			b[i] = b[i] - b[e]*a[e][i];
			for(j = 1; j <= m+n; j++)
			{
				if(NB[j] == SKUP_N && j != e)
				{
					a[i][j] = a[i][j] - a[i][e]*a[e][j];
				}
			}
			a[i][l] = -a[i][e]*a[e][l];
		}
	}
	
	for(i = 1; i <= m+n; i++)
	{
		if(NB[i] == SKUP_N && i != e)
		{
			c[i] = c[i] - c[e]*a[e][i];
		}
	}
	
	c[l] = -c[e]*a[e][l];
	
	v = v + c[e]*b[e];
	
	NB[e] = SKUP_B;
	NB[l] = SKUP_N;
}


int main()
{
	int e, l;
	int i, j;
	unesiPodatke();
	while((e = nadjiUlaz()) != -1)
	{
		l = nadjiIzlaz(e);
		if(l == -1)
		{
			printf("nije resivo\n");
			break;
		}
		else
		{
			pivot(e, l);
		}
	}
	
	
	if(e == -1)
	{
		printf("%.3lf\n", v);
		for(i = 1; i <= n; i++)
		{
			if(NB[i] == SKUP_B)
			{
				x[i] = b[i];

			}
			else
				x[i] = 0;
			
			printf("%.3lf ", x[i]);
		}
		printf("\n");
	}
	return 0;
}
