#include <stdio.h>
#include <stdlib.h>

#define SKUP_B 1
#define SKUP_N 0

double **a,*c,*x,*b,v;
int n,m,*BN;


void ucitajPodatke()
{
	int i;
	
	n = 3;
	m = 7;
	
	a = (double **)malloc((n+m)*sizeof(double*));
		b = (double *)malloc((n+m)*sizeof(double));
				c = (double *)malloc((n+m)*sizeof(double));
						x = (double *)malloc((n+m)*sizeof(double));
								BN = (int *)malloc((n+m)*sizeof(int));
	
	for (i = 0; i < n+m; i++)
		a[i] = (double *)malloc((n+m)*sizeof(double));
	
	double jecamS,jecamT,jecamN,hmeljS,hmeljN,hmeljT,psenicaS,psenicaT,psenicaN;
	double kvasacS,kvasacT,kvasacN,cenaS,cenaT,cenaN;
	
	scanf("%lf%lf%lf%lf",&jecamS,&hmeljS,&psenicaS,&kvasacS);
	scanf("%lf%lf%lf%lf",&jecamT,&hmeljT,&psenicaT,&kvasacT);
	scanf("%lf%lf%lf%lf",&jecamN,&hmeljN,&psenicaN,&kvasacN);
	scanf("%lf%lf%lf",&cenaS,&cenaT,&cenaN);
	
	c[0] = (10.0*cenaS)/100.0; 
	c[1] = (15.0*cenaT)/100.0;
	c[2] = (22.0*cenaN)/100.0;
	
	for (i = 0; i < n; i++)
	{
		BN[i] = SKUP_N;
		b[i] = 0;
	}
	
	for (i = n; i < 7; i++)
		scanf("%lf",&b[i]);
	
	b[7] = 1000;
	b[8] = 1000;
	b[9] = 1000;

	for (i = n; i < n+m; i++)
	{
		BN[i] = SKUP_B;
		c[i] = 0;
	}
	
	a[n][0] = jecamS;
	a[n][1] = jecamT;
	a[n][2] = jecamN;
	
	a[n+1][0] = hmeljS;
	a[n+1][1] = hmeljT;
	a[n+1][2] = hmeljN;
	
	a[n+2][0] = psenicaS;
	a[n+2][1] = psenicaT;
	a[n+3][2] = psenicaN;
	
	a[n+3][0] = kvasacS;
	a[n+3][1] = kvasacT;
	a[n+3][2] = kvasacN;
	
	a[n+4][0] = (jecamS+hmeljS+psenicaS+kvasacS)/100;
	a[n+4][1] = 0;
	a[n+4][2] = 0;
	
	a[n+5][0] = 0;
	a[n+5][1] = (jecamT+hmeljT+psenicaT+kvasacT)/100;
	a[n+5][2] = 0;
	
	a[n+6][0] = 0;
	a[n+6][1] = 0;
	a[n+6][2] = (jecamN+hmeljN+psenicaN+kvasacN)/100;
	
	
	v = 0;
	
}


int nadjiUlaz()
{
	int i,e=-1;
	for (i = 0; i < n+m; i++)
	{
		if (BN[i] == SKUP_N && c[i]>0)
		{
			e = i;
			break;
		}
	}
	return e;
}

int nadjiIzlaz(int e)
{
	int i,l=-1;
	double min;
	for (i = 0; i < n+m; i++)
	{
		if (BN[i] == SKUP_B && a[i][e]>0)
		{
			if (l==-1)
			{
				min = b[i]/a[i][e];
				l = i;
			}
			else if (b[i]/a[i][e] < min)
			{
				min = b[i]/a[i][e];
				l = i;
			}
		}
	}
	return l;
}

void pivot(int e,int l)
{
	int i,j;
	b[e] = b[l]/a[l][e];
	for (j = 0; j < n+m; j++)
	{
		if (BN[j]==SKUP_N && j!=e)
		{
			a[e][j] = a[l][j]/a[l][e];
		}
	}
	a[e][l] = 1/a[l][e];
	
	for (i = 0; i < n+m; i++)
	{
		if (BN[i]==SKUP_B && i!=l)
		{
			b[i] = b[i] - a[i][e] * b[e];
			for (j = 0; j < n+m; j++)
			{
				if (BN[j]==SKUP_N && j!=e)
				{
					a[i][j] = a[i][j] - a[i][e]*a[e][j];
				}
			}
			a[i][l] =  - a[i][e]*a[e][l];
		}
	}
	v = v + c[e] * b[e];
	for (j = 0; j < n+m; j++)
	{
		if (BN[j]==SKUP_N && j!=e)
		{
			c[j] = c[j] - c[e] * a[e][j];
		}
	}
	c[l] = - c[e] * a[e][l];
	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
}

int main()
{
	int i,e,l;
	ucitajPodatke();
	while ((e=nadjiUlaz())!=-1)
	{
		l=nadjiIzlaz(e);
		if (l==-1)
		{
			printf("Problem neogranicen ! \n");
			break;
		}
		else pivot(e,l);
	}
	if (e==-1)
	{
		for (i = 0; i < n; i++)
		{
			if (BN[i] == SKUP_B)
			{
				x[i] = b[i];
			}
			else x[i] = 0;
		}
		printf("%.3lf\n",v);
		for (i = 0; i < n; i++)
		{
			printf("%.3lf\t",x[i]);
		}
		printf("\n");
	}
	
	return 0;
}
